// FTPPutDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "FTPPut.h"
#include "FTPPutDlg.h"
#include "LinkText.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char*	CFTPPutDlg::s_settingFileName = "FTPPut.txt";

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CLinkText	m_linkText;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK_TEXT, m_linkText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString	s;
	s.Format("FTPPut Version %.2f",CFTPPutApp::s_appVersion * 0.01);
	GetDlgItem(IDC_VERSION)->SetWindowText(s);
	return TRUE;
}

const char* ChangeLong(const char* p)
{
	static char	buf[1024];
	char*		q = buf;
	unsigned	i,j;
	while ((i = *p++) != 0) {
		j = i&0xf;
		i /= 16;
		*q++ = i+'a';
		*q++ = j+'a';
	}
	*q = 0;
	return buf;
}

const char* ChangeShort(const char* p)
{
	static char	buf[1024];
	char*		q = buf;
	unsigned	i,j;
	while ((i = *p++) != 0) {
		if (!(j = *p++)) return 0;
		*q++ = ((i-'a')<<4) + j-'a';
	}
	*q = 0;
	return buf;
}

/////////////////////////////////////////////////////////////////////////////
// CFTPPutDlg _CAO

CFTPPutDlg::CFTPPutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFTPPutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFTPPutDlg)
	m_local = _T("");
	m_passwd = _T("");
	m_server = _T("");
	m_userID = _T("");
	m_home = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	/*
	*/
	char	buf[512],*p;
	GetModuleFileName(0,buf,sizeof(buf));
	p = strrchr(buf,'\\');
	if (p) *p = 0;
	chdir(buf);
	int		ver = 0;
	m_size.cx = 400;
	m_size.cy = 175;
	CFile	f;
	if (f.Open(s_settingFileName,CFile::modeRead)) {
		CArchive	ar(&f,CArchive::load);
		CString		s;
		ar.ReadString(s);
		sscanf(s,"%d",&ver);
		ar.ReadString(s);
		sscanf(s,"%d %d",&m_size.cx,&m_size.cy);
		ar.ReadString(m_server);
		if (ver >= 110)
			ar.ReadString(m_home);
		ar.ReadString(m_local);
		ar.ReadString(m_userID);
		ar.ReadString(s);
		m_passwd = ChangeShort(s);
		f.Close();
	}
}

void CFTPPutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTPPutDlg)
	DDX_Text(pDX, IDC_LOCAL, m_local);
	DDX_Text(pDX, IDC_PASSWD, m_passwd);
	DDX_Text(pDX, IDC_SERVER, m_server);
	DDX_Text(pDX, IDC_USERID, m_userID);
	DDX_Text(pDX, IDC_HOME, m_home);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFTPPutDlg, CDialog)
	//{{AFX_MSG_MAP(CFTPPutDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CFTPPutDlg::FTPPut()
{
	int	i,l, n = m_data.size();
	l = m_local.GetLength();
	if (!l || m_server.IsEmpty() || m_userID.IsEmpty() || m_passwd.IsEmpty()) {
		MB("Set all parameter");
		return;
	}
	CString		t;
	try {
		CFtpConnection* pf = m_ses.GetFtpConnection(
			m_server,m_userID,m_passwd);
		if (!m_home.IsEmpty())
			pf->SetCurrentDirectory(m_home);
		for (i=0;i<n;++i) {
			CString& s = m_data[i];
			if (strnicmp(m_local,s,l)) {
				MB("Don't put "+s);
				continue;
			}
			t = s.Right(s.GetLength() - l - 1);
			t.Replace('\\','/');
			pf->PutFile(s,t);
		}
	}
	catch (CInternetException* e) {
		char buf[128];
		e->GetErrorMessage(buf,sizeof(buf)-1);
		MB(buf);
		e->Delete();
	}
}

/////////////////////////////////////////////////////////////////////////////
// CFTPPutDlg bZ[W nh

BOOL CFTPPutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty()) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon,TRUE);
	SetIcon(m_hIcon,FALSE);
	
	m_lay.SetType(GetDlgItem(IDOK),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDCANCEL),CLayoutManager::FixSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_SERVER),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_HOME),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_LOCAL),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_USERID),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.SetType(GetDlgItem(IDC_PASSWD),CLayoutManager::FreeSize,CLayoutManager::Default);
	m_lay.Reset();
	SetWindowPos(0,0,0,m_size.cx,m_size.cy,SWP_NOMOVE);
	return TRUE;
}

void CFTPPutDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CFTPPutDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this);
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	} else {
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CFTPPutDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFTPPutDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if (nType == 0 || nType == 2) m_lay.Layout();
}

/*
void CFTPPutDlg::OnDropFiles(HDROP hDropInfo) 
{
	int		i,n;
	char	buf[MAX_PATH+1];
	n = ::DragQueryFile(hDropInfo,0xffffffff,buf,sizeof(buf)-1);
	for (i=0;i<n;i++) {
		::DragQueryFile(hDropInfo,i,buf,sizeof(buf)-1);
		MB(buf);
	}
	::DragFinish(hDropInfo);
}*/

void CFTPPutDlg::OnOK() 
{
	if (!UpdateData()) return;
	CStdioFile		f;
	if (!f.Open(s_settingFileName,CFile::modeCreate | CFile::modeWrite))
		return;
	m_local.TrimRight('\\');
	CRect		r;
	GetWindowRect(&r);
	CString			s;
	s.Format("%d\n%d %d\n",CFTPPutApp::s_appVersion,r.Width(),r.Height());
	f.WriteString(s);
	f.WriteString(m_server+"\n");
	f.WriteString(m_home+"\n");
	f.WriteString(m_local+"\n");
	f.WriteString(m_userID+"\n");
	f.WriteString(CString(ChangeLong(m_passwd))+"\n");
	CDialog::OnOK();
}
